// test.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include <windows.h>
#include <tlhelp32.h>
#include <psapi.h>
#include <fstream>
#include <string.h>
#include <direct.h>
#include <iostream>
#include <sstream>
#include <accctrl.h>
#include <aclapi.h>
#include <stdlib.h>
#include <direct.h>
#include <shlwapi.h>
#include <atlbase.h>
#include <algorithm>

#define BUFSIZE MAX_PATH
#define ARRAY_SEPARATOR 10


/**
 * Determine is a given process is running in memory.
 * Usage: detectprocess [fullprocesspath]
 * For example:  detectproduct E:\IBM\WebSphere\ND\java\bin\java.exe E:\IBM\WebSphere\ND\java\jre\bin\java.exe 
 *
 * Glen Shortliffe, IBM Corp.
 * 
 * Created: April 4, 2005.
 *
 * Revised by David VandePol
 * 
 * November 17, 2008
 */

//  Forward declarations:
void printError( TCHAR* msg );
BOOL SetPrivilege(HANDLE hToken,LPCTSTR lpszPrivilege,BOOL bEnablePrivilege);
int GetProcessList ();
int ListProcessModules( DWORD dwPID, int, _TCHAR*[]);
BOOL ListProcessModules( DWORD dwPID ) ;
BOOL ListProcessThreads( DWORD dwPID ) ;
std::wstring DisplayVolumePaths(__in PWCHAR VolumeName);
void populateVolumeMappingSize();


void PrintProcessNameAndID( DWORD processID );

using namespace std;

wstring volumeMapping[20]; 
wstring userPathString[20];
int volumeMappingSize = 0;
int numberOfUserPaths;
BOOL isDebug = false;
BOOL isStepThrough = false;


int _tmain(int argc, _TCHAR* argv[]){
	
  if (argc < 2) {
	printf( "Usage: %s [fullprocesspath] [...]", argv[0] );
	return ( -1 );
  }
 
  for (int i = 1 ; i < argc; i++){
	  wstring temp = argv[i];
	  if (temp.compare(L"-is:debug") == 0){
			isDebug = true;
			continue;
		}
	  if (temp.compare(L"-is:stepThrough") == 0){
		  isStepThrough = true;
		  isDebug = true;
		  continue;
	  }
  }
  numberOfUserPaths = 0;
  populateVolumeMappingSize();
  int x = 1;
  
  for (int i = 1 ; i < argc; i++){
	  wstring temp = argv[i];
	  if (temp.compare(L"-is:debug") == 0){
			continue;
	  }
	  if (temp.compare(L"-is:stepThrough") == 0){
			continue;
	   }
	  if (isDebug) _tprintf( TEXT("\nUser Argument: %s\n"), argv[i]); 
		
	  std::transform(temp.begin(), temp.end(), temp.begin(), ::toupper);
	  for(wstring::size_type i = temp.find(L"/"); i != wstring::npos; i = temp.find(L"/", ++i))
	  {
		if(i > 0 && (temp[i-1] == L'/')) continue;
        temp.replace(i++, 1, L"\\");
      }
	
		
	  for (int j = 0 ; j <= volumeMappingSize; j++){
		  if (isDebug) _tprintf( TEXT("\tSearching for index of: %s in: %s\n"), volumeMapping[j+ ARRAY_SEPARATOR].c_str(), temp.c_str());
		  if (volumeMapping[j + ARRAY_SEPARATOR].size() != NULL && volumeMapping[j + ARRAY_SEPARATOR].size() == 0){
			  if (isDebug) _tprintf( TEXT("\tString length of %s is %d : SKIP if 0\n"), volumeMapping[j+ ARRAY_SEPARATOR].c_str(), volumeMapping[j + ARRAY_SEPARATOR].size());
			  continue;
		  }
		  int found = temp.find(volumeMapping[j+ ARRAY_SEPARATOR]);
			  if (found!=string::npos){
				  if (isDebug) _tprintf( TEXT("\tFound index of: %s in: %s and it is changed to: "), volumeMapping[j+ ARRAY_SEPARATOR].c_str(), temp.c_str());
				  temp.replace(found,volumeMapping[j+ ARRAY_SEPARATOR].length(), volumeMapping[j]);
				   if (isDebug) _tprintf( TEXT("%s\n"), temp.c_str());
				  break;
			  }
	  }
	  
	  userPathString[numberOfUserPaths++] = temp;
  }
  if (numberOfUserPaths <= 0) {
	printf( "You must provide at least one processpath\n", argv[0] );
	printf( "Usage: %s [fullprocesspath] [...]", argv[0] );
	return ( -1 );
  }
 
  if (isDebug){
	  _tprintf( TEXT("Final processes search strings total : %d\n"),numberOfUserPaths);
	  for (int i = 0; i < numberOfUserPaths; i++){
		  _tprintf( TEXT("\t%s\n"), userPathString[i].c_str());
	  }
  }
  
  int iProcessCount = 0;

  iProcessCount = GetProcessList();

  printf( "Found %i processes", iProcessCount );

  if (isDebug){
	  _tprintf( TEXT("\n\nFinal Results total : %d\n"), numberOfUserPaths);
	  for (int i = 0; i <= numberOfUserPaths; i++){
		  _tprintf( TEXT("\t%s\n"), userPathString[i].c_str());
	  }
  }
	
  return iProcessCount;
 // */
}





void printError( TCHAR* msg )
{
  DWORD eNum;
  TCHAR sysMsg[256];
  TCHAR* p;

  eNum = GetLastError( );
  FormatMessage( FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
         NULL, eNum,
         MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
         sysMsg, 256, NULL );

  // Trim the end of the line and terminate it with a null
  p = sysMsg;
  while( ( *p > 31 ) || ( *p == 9 ) )
    ++p;
  do { *p-- = 0; } while( ( p >= sysMsg ) &&
                          ( ( *p == '.' ) || ( *p < 33 ) ) );

  // Display the message
  printf( "\n  WARNING: %s failed with error %d (%s)", msg, eNum, sysMsg );
}

BOOL SetPrivilege(HANDLE hToken, LPCTSTR lpszPrivilege,BOOL bEnablePrivilege)   // to enable or disable privilege
					 
{
	TOKEN_PRIVILEGES tp;
	LUID luid;

	if ( !LookupPrivilegeValue( 
			NULL,            // lookup privilege on local system
			lpszPrivilege,   // privilege to lookup 
			&luid ) )        // receives LUID of privilege
	{
		if (ERROR_ACCESS_DENIED == GetLastError()){
			printf("EROR_ACCESS_DENIED: ");
		}if (ERROR_INVALID_HANDLE == GetLastError()){
			printf("ERROR_INVALID_HANDLE: ");
		}
		printf("LookupPrivilegeValue error: %u\n", GetLastError() ); 
		return FALSE; 
	}


	tp.PrivilegeCount = 1;
	tp.Privileges[0].Luid = luid;
	if (bEnablePrivilege)
		tp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
	else
		tp.Privileges[0].Attributes = 0;

	// Enable the privilege or disable all privileges.


	if ( !AdjustTokenPrivileges(
		   hToken, 
		   FALSE, 
		   &tp, 
		   sizeof(TOKEN_PRIVILEGES), 
		   (PTOKEN_PRIVILEGES) NULL, 
		   (PDWORD) NULL) )
	{ 
		if (ERROR_ACCESS_DENIED == GetLastError()){
			printf("EROR_ACCESS_DENIED: ");
		}if (ERROR_INVALID_HANDLE == GetLastError()){
			printf("ERROR_INVALID_HANDLE: ");
		}
		  printf("AdjustTokenPrivileges error: %u\n", GetLastError() ); 
		  return FALSE; 
	} 

	if (GetLastError() == ERROR_NOT_ALL_ASSIGNED)

	{
		  printf("The token does not have the specified privilege. \n");
		  return FALSE;
	} 

	return TRUE;
}


int GetProcessList ()
{
	HANDLE hProcessSnap = NULL;
	BOOL bRet = FALSE;
	PROCESSENTRY32 pe32 = {0};
	int numberOfRunningProcessesFound = 0;

	// Take a snapshot of all processes in the system.

	hProcessSnap = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);

	if (hProcessSnap == INVALID_HANDLE_VALUE){
		if (isDebug) printf("\nFailure to create Handle with CreateToolhelp32Snapshot: INVALID_HANDLE_VALUE");
		return 0;
	}

	// Fill in the size of the structure before using it.

	pe32.dwSize = sizeof(PROCESSENTRY32);


	// Walk the snapshot of the processes, and for each process,
	// display information.

	if (Process32First(hProcessSnap, &pe32))
	{

	//DWORD dwPriorityClass;
	BOOL bGotModule = FALSE;
	MODULEENTRY32 me32 = {0};

	do
	{
		

	//ListProcessModules(pe32.th32ProcessID);
	//ListProcessThreads(pe32.th32ProcessID);
	TCHAR buffer[MAX_PATH] = TEXT("<File name not found, Handle was found>");
	TCHAR buffer2[MAX_PATH] = TEXT("<File name not found, Handle was not found>");

	SetLastError(0);
	HANDLE Handle = OpenProcess(PROCESS_ALL_ACCESS , FALSE, pe32.th32ProcessID);
	
		if (Handle != 0){
			if (isDebug) printf("\nPROCESS_ALL_ACCESS WORKED: Handle: %d\tPID: %d", Handle, pe32.th32ProcessID);
		} else if (ERROR_ACCESS_DENIED == GetLastError()){
			if (isDebug) printf("\nPROCESS_ALL_ACCESS ERROR_ACCESS_DENIED: Handle: %d\tPID: %d", Handle, pe32.th32ProcessID);
		} else if (ERROR_INVALID_HANDLE == GetLastError()){
			if (isDebug) printf("\nPROCESS_ALL_ACCESS ERROR_INVALID_HANDLE: Handle: %d\tPID: %d", Handle, pe32.th32ProcessID);
		}
	if (Handle == 0)
	{
		SetLastError(0);
		Handle = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ , FALSE, pe32.th32ProcessID);
		if (Handle != 0){
			if (isDebug) printf("\nPROCESS_QUERY_INFORMATION | PROCESS_VM_READ WORKED: Handle: %d\tPID: %d", Handle, pe32.th32ProcessID);
		} else if (ERROR_ACCESS_DENIED == GetLastError()){
			if (isDebug) printf("\nPROCESS_QUERY_INFORMATION | PROCESS_VM_READ ERROR_ACCESS_DENIED: Handle: %d\tPID: %d", Handle, pe32.th32ProcessID);
		}else if (ERROR_INVALID_HANDLE == GetLastError()){
			if (isDebug) printf("\nPROCESS_QUERY_INFORMATION | PROCESS_VM_READ ERROR_INVALID_HANDLE: Handle: %d\tPID: %d", Handle, pe32.th32ProcessID);
		}
	}
	
	if (Handle == 0)
	{
		SetLastError(0);
		Handle = OpenProcess(PROCESS_QUERY_INFORMATION , FALSE, pe32.th32ProcessID);
		if (Handle != 0){
			if (isDebug) printf("\nPROCESS_QUERY_INFORMATION WORKED: Handle: %d\tPID: %d", Handle, pe32.th32ProcessID);
		} else if (ERROR_ACCESS_DENIED == GetLastError()){
			if (isDebug) printf("\nPROCESS_QUERY_INFORMATION ERROR_ACCESS_DENIED: Handle: %d\tPID: %d", Handle, pe32.th32ProcessID);
		} else if (ERROR_INVALID_HANDLE == GetLastError()){
			if (isDebug) printf("\nPROCESS_QUERY_INFORMATION ERROR_INVALID_HANDLE: Handle: %d\tPID: %d", Handle, pe32.th32ProcessID);
		}


	}
	
	if (Handle == 0) 
	{ 
		SetLastError(0);
		Handle = OpenProcess(PROCESS_QUERY_LIMITED_INFORMATION , FALSE, pe32.th32ProcessID);
		if (Handle != 0){
			if (isDebug) printf("\nPROCESS_QUERY_LIMITED_INFORMATION WORKED: Handle: %d\tPID: %d", Handle, pe32.th32ProcessID);
		} else if (ERROR_ACCESS_DENIED == GetLastError()){
			if (isDebug) printf("\nPROCESS_QUERY_LIMITED_INFORMATION ERROR_ACCESS_DENIED: Handle: %d\tPID: %d", Handle, pe32.th32ProcessID);
		} else if (ERROR_INVALID_HANDLE == GetLastError()){
			if (isDebug) printf("\nPROCESS_QUERY_LIMITED_INFORMATION ERROR_INVALID_HANDLE: Handle: %d\tPID: %d", Handle, pe32.th32ProcessID);
		}
	} 
	 if (Handle != 0)
	{ 
		
		 GetProcessImageFileName (Handle, buffer, MAX_PATH);
		 wstring processPath = buffer;
		 std::transform(processPath.begin(), processPath.end(), processPath.begin(), ::toupper);
		 if (isDebug)  _tprintf( TEXT("\n\nPath of process: \n\t%s\n"), processPath.c_str());
		 //Compare to String
		 for (int i = 0; i < numberOfUserPaths; i++){
			 wstring userpath = userPathString[i];
			 int compare = processPath.compare(userPathString[i]);
			 if (compare == 0){
				 if (isDebug) {
					 _tprintf( TEXT("\n\n****************************************************************\n"));
					 _tprintf( TEXT("\tFOUND\t%s\n"), processPath.c_str());
					 _tprintf( TEXT("****************************************************************\n"));
				 }
				 userPathString[i].append(L" -- Found");
				 numberOfRunningProcessesFound++;
				 break;
			 }
			 if (isDebug) _tprintf(TEXT("\nNO MATCH FOUND BETWEEN \n\t%s \nAND \n\t%s\n"), userpath.c_str(), processPath.c_str());
		 }
				
		if (ERROR_ACCESS_DENIED == GetLastError()){
			if (isDebug) printf("\nERROR_ACCESS_DENIED: for Get ProcessImageFileName: %d\tPID: %d", Handle, pe32.th32ProcessID);
		}if (ERROR_INVALID_HANDLE == GetLastError()){
			if (isDebug) printf("\nERROR_INVALID_HANDLE: for Get ProcessImageFileName: %d\tPID: %d", Handle, pe32.th32ProcessID);
		}
	} else {
		if (isDebug) _tprintf(TEXT("\nHandle not found for filename: %s\t Absolute Path cannot be found"), pe32.szExeFile);
	}
	CloseHandle(Handle);
	//printf( "\nPID\t\t\t%d", pe32.th32ProcessID);
	//printf( "\nThread Count\t\t%d", pe32.cntThreads);
	//if (isDebug) _tprintf(TEXT("\nThread Exe File Name\t\t%s"), pe32.szExeFile);
	//PAUSE
	
	if (isDebug) printf("\n\n#########################################################################\n");
	if (isStepThrough) { 
		printf("\nPress Any Key To Search next process...\n");
		getchar();
	}
	

	}
	while (Process32Next(hProcessSnap, &pe32));
	bRet = TRUE;
	}
	
	CloseHandle (hProcessSnap);
	return numberOfRunningProcessesFound;
}




int ListProcessModules( DWORD dwPID, int argc, _TCHAR* argv[] )
{
		USES_CONVERSION;
	int iProcessCount = 0;

	//HMODULE hMods[20048];
	 HMODULE hMod;
    DWORD cbNeeded;
    unsigned int i;
    int j;


	 HANDLE hProcess = OpenProcess( PROCESS_VM_READ,
                                   FALSE, dwPID );
	


    if (NULL == hProcess)
    {
		printf( "NULL == hProcess for %d\n", dwPID );		
	}

	TCHAR szProcessName[MAX_PATH] = TEXT("<unknown>");
	TCHAR szModName[MAX_PATH] = TEXT("<unknown>");
	
	if ( EnumProcessModules( hProcess, &hMod, sizeof(hMod), 
             &cbNeeded) )
    {
  
		printf( "Got modules for PID: %d", dwPID );

        for ( i = 0; i < (cbNeeded / sizeof(HMODULE)); i++ )
        {
           // char szModName[MAX_PATH];
			//LPWSTR szModName = (LPWSTR) malloc(sizeof(wchar_t)*(MAX_PATH + 5));
            GetModuleBaseName( hProcess, hMod, szProcessName, 
                               sizeof(szProcessName)/sizeof(TCHAR) );
			GetModuleFileNameEx( hProcess, hMod, szModName,sizeof(szModName)/sizeof(TCHAR));
			 _tprintf( TEXT("ProcessName : \t%s \t Module Name : \t%s \n"), szProcessName, szModName);
            //                          (MAX_PATH + 5))
            // Get the full path to the module's file.
           // if ( GetModuleFileNameEx( hProcess, hMods[i], szModName,
            //                          (MAX_PATH + 5)))
           // {
                // Print the module name and handle value.
		
		wstring wsszModName = szModName;
	 
			for( j = 1; j < argc; j++ )
			{

				wstring test = argv[j];
				if( wsszModName.compare( test ) == 0 )
				{
		//			printf("Found process module: %s (0x%08X)\n", szModName, hMods[i] );
		//			printf( "PID=[0x%08X] PROCESS=[%s]\n", hMods[i], szModName );
					iProcessCount++;
				}
			}
           // }
        }
    }
    else
    {
		if (ERROR_ACCESS_DENIED == GetLastError()){
			printf("EROR_ACCESS_DENIED: ");
		}if (ERROR_INVALID_HANDLE == GetLastError()){
			printf("ERROR_INVALID_HANDLE: ");
		}
		printf(" \t%d\n", dwPID);
//	printf( "Got no modules for: %d, the cbNeeded was: %d, last error set to: %d\n", dwPID, cbNeeded, GetLastError() );
    }

    CloseHandle( hProcess );
	

    return( iProcessCount );
}
BOOL ListProcessModules( DWORD dwPID ) 
{ 
  HANDLE hModuleSnap = INVALID_HANDLE_VALUE; 
  MODULEENTRY32 me32; 
 
//  Take a snapshot of all modules in the specified process. 
  hModuleSnap = CreateToolhelp32Snapshot( TH32CS_SNAPMODULE, dwPID ); 
  if( hModuleSnap == INVALID_HANDLE_VALUE ) 
  { 
    printf( "CreateToolhelp32Snapshot (of modules)" ); 
    return( FALSE ); 
  } 
 
//  Set the size of the structure before using it. 
  me32.dwSize = sizeof( MODULEENTRY32 ); 
    _tprintf(TEXT( "\n\n     FIRST:     %s"), me32.szExePath ); 
 
//  Retrieve information about the first module, 
//  and exit if unsuccessful 
  if( !Module32First( hModuleSnap, &me32 ) ) 
  { 
    printf( "Module32First" ); // Show cause of failure 
    CloseHandle( hModuleSnap );    // Must clean up the
                                   //   snapshot object! 
    return( FALSE ); 
  } 
 
//  Now walk the module list of the process, 
//  and display information about each module 
  do 
  { 
  _tprintf(TEXT( "\n\n     MODULE NAME:     %s"), me32.szModule ); 
  _tprintf(TEXT( "\n\n     MODULE PATH:     %s"), me32.szExePath ); 
  
 
    printf( "\n     executable     = %s",
      me32.szExePath ); 
    printf( "\n     process ID     = 0x%08X",
      me32.th32ProcessID ); 
    printf( "\n     ref count (g)  =     0x%04X",
      me32.GlblcntUsage ); 
    printf( "\n     ref count (p)  =     0x%04X",
      me32.ProccntUsage ); 
    printf( "\n     base address   = 0x%08X",
      (DWORD) me32.modBaseAddr ); 
    printf( "\n     base size      = %d",
      me32.modBaseSize ); 
 
  } while( Module32Next( hModuleSnap, &me32 ) ); 
 
//  Do not forget to clean up the snapshot object. 
  CloseHandle( hModuleSnap ); 
  return( TRUE ); 
} 
BOOL ListProcessThreads( DWORD dwOwnerPID ) 
{ 
  HANDLE hThreadSnap = INVALID_HANDLE_VALUE; 
  THREADENTRY32 te32; 
 
  // Take a snapshot of all running threads  
  hThreadSnap = CreateToolhelp32Snapshot( TH32CS_SNAPTHREAD, 0 ); 
  if( hThreadSnap == INVALID_HANDLE_VALUE ) 
    return( FALSE ); 
 
  // Fill in the size of the structure before using it. 
  te32.dwSize = sizeof(THREADENTRY32 ); 
 
  // Retrieve information about the first thread,
  // and exit if unsuccessful
  if( !Thread32First( hThreadSnap, &te32 ) ) 
  {
    printError( TEXT("Thread32First") ); // show cause of failure
    CloseHandle( hThreadSnap );          // clean the snapshot object
    return( FALSE );
  }

  // Now walk the thread list of the system,
  // and display information about each thread
  // associated with the specified process
  do 
  { 
    if( te32.th32OwnerProcessID == dwOwnerPID )
    {
      printf( "\n\n     THREAD ID      = 0x%08X", te32.th32ThreadID ); 
      printf( "\n     Base priority  = %d", te32.tpBasePri ); 
      printf( "\n     Delta priority = %d", te32.tpDeltaPri ); 
    }
  } while( Thread32Next(hThreadSnap, &te32 ) ); 

  CloseHandle( hThreadSnap );
  return( TRUE );
}

wstring DisplayVolumePaths(__in PWCHAR VolumeName)
{
    DWORD  CharCount = MAX_PATH + 1;
    PWCHAR Names     = NULL;
    PWCHAR NameIdx   = NULL;
    BOOL   Success   = FALSE;
	wstring name = L"";

    for (;;) 
    {
        //
        //  Allocate a buffer to hold the paths.
        Names = (PWCHAR) new BYTE [CharCount * sizeof(WCHAR)];

        if ( !Names ) 
        {
            //
            //  If memory can't be allocated, return.
            return L"";
        }

        //
        //  Obtain all of the paths
        //  for this volume.
        Success = GetVolumePathNamesForVolumeNameW(
            VolumeName, Names, CharCount, &CharCount
            );

        if ( Success ) 
        {
            break;
        }

        if ( GetLastError() != ERROR_MORE_DATA ) 
        {
            break;
        }

        //
        //  Try again with the
        //  new suggested size.
        delete [] Names;
        Names = NULL;
    }

    if ( Success )
    {
        //
        //  Display the various paths.
        for ( NameIdx = Names; 
              NameIdx[0] != L'\0'; 
              NameIdx += wcslen(NameIdx) + 1 ) 
        {
            //wprintf(L"  %s", NameIdx);
			name = NameIdx;
        }
        //wprintf(L"\n");
    }

    if ( Names != NULL ) 
    {
        delete [] Names;
        Names = NULL;
    }
	
    return name;
}

void populateVolumeMappingSize()
{
    DWORD  CharCount            = 0;
    WCHAR  DeviceName[MAX_PATH] = L"";
    DWORD  Error                = ERROR_SUCCESS;
    HANDLE FindHandle           = INVALID_HANDLE_VALUE;
    BOOL   Found                = FALSE;
    size_t Index                = 0;
    BOOL   Success              = FALSE;
    WCHAR  VolumeName[MAX_PATH] = L"";
	
	volumeMappingSize = 0;
    //  Enumerate all volumes in the system.
    FindHandle = FindFirstVolumeW(VolumeName, ARRAYSIZE(VolumeName));

    if (FindHandle == INVALID_HANDLE_VALUE)
    {
        Error = GetLastError();
        if (isDebug) wprintf(L"FindFirstVolumeW failed with error code %d\n", Error);
        return;
    }

    for (;;)
    {
        //
        //  Skip the \\?\ prefix and remove the trailing backslash.
        Index = wcslen(VolumeName) - 1;

        if (VolumeName[0]     != L'\\' ||
            VolumeName[1]     != L'\\' ||
            VolumeName[2]     != L'?'  ||
            VolumeName[3]     != L'\\' ||
            VolumeName[Index] != L'\\') 
        {
            Error = ERROR_BAD_PATHNAME;
            if (isDebug) wprintf(L"FindFirstVolumeW/FindNextVolumeW returned a bad path: %s\n", VolumeName);
            break;
        }

        //
        //  QueryDosDeviceW doesn't allow a trailing backslash,
        //  so temporarily remove it.
        VolumeName[Index] = L'\0';

        CharCount = QueryDosDeviceW(&VolumeName[4], DeviceName, ARRAYSIZE(DeviceName)); 

        VolumeName[Index] = L'\\';

        if ( CharCount == 0 ) 
        {
            Error = GetLastError();
            if (isDebug) wprintf(L"QueryDosDeviceW failed with error code %d\n", Error);
            break;
        }
		wstring device = DeviceName;
		device.append(L"\\");
		std::transform(device.begin(), device.end(), device.begin(), ::toupper);
		volumeMapping[volumeMappingSize] = device;
		wstring volume = DisplayVolumePaths(VolumeName);
		std::transform(volume.begin(), volume.end(), volume.begin(), ::toupper);
		volumeMapping[volumeMappingSize + ARRAY_SEPARATOR] = volume;
		if (isDebug) wprintf(L"Mapping: %s to: %s\n", volumeMapping[volumeMappingSize].c_str(), volumeMapping[volumeMappingSize + ARRAY_SEPARATOR].c_str());

        //  Move on to the next volume.
        Success = FindNextVolumeW(FindHandle, VolumeName, ARRAYSIZE(VolumeName));

        if ( !Success ) 
        {
            Error = GetLastError();

            if (Error != ERROR_NO_MORE_FILES) 
            {
                if (isDebug) wprintf(L"FindNextVolumeW failed with error code %d\n", Error);
                break;
            }

            //
            //  Finished iterating
            //  through all the volumes.
            Error = ERROR_SUCCESS;
            break;
        }
		volumeMappingSize++;
    }

    FindVolumeClose(FindHandle);
    FindHandle = INVALID_HANDLE_VALUE;

    return;
}